<?php

/**
 * This class handles the adding 
 * tablerows in the DOM structure. A TableRow must then be filled with
 * TableCells
 *  
 * $Id: TableRow.class.php,v 1.1.1.1 2006/09/17 15:41:38 Andi Exp $
 *
 * @license    http://www.gnu.org/licenses/lgpl.html GNU Lesser General Public License
 * @copyright  Copyright in 2006 by Andi Hotz
 * @copyright  GNU Lesser General Public License
 * @author     Andi Hotz
 * @version    $Revision: 1.1.1.1 $
 * @package    ODFLib
 * @subpackage odfNodes
 * @since      0.0.1
 */
class TableRow{
	/**
	 * DOMDocument
	 */
	private $dom;
	
	/**
	 * Initialise the DOMDocument.
	 * @param DOMDocument $dom
	 */
	public function __construct(DOMDocument $dom){
		$this->dom=$dom;
	}

	/**
	 * Add a new table row
	 * after $afterNode
	 * @param DOMNode $tableNode The parent node (table-node) in the
	 * the DOM structure
	 * @return the new table node
	 */
	public function addTableRow(DOMNode $tableNode){
		$par = $this->dom->createElement('table:table-row');
		require_once('Replace.class.php');
		return $tableNode->appendChild($par);
	}

	/**
	 * Add a new table header row 
	 * after $afterNode
	 * @param DOMNode $tableNode After this node the paragraph
	 * is added in the DOM structure
	 * @return the new table node
	 */
	public function addTableHeaderRow(DOMNode $tableNode){
		$par = $this->dom->createElement('table:table-header-rows');
		$inner = $this->dom->createelement('table:table-row');
		$par->appendChild($inner);
		require_once('Replace.class.php');
		return $tableNode->appendChild($par);
	}
	
}
?>